
import java.io.IOException;
import java.io.PrintWriter;
import html.HtmlWriter;

import javax.servlet.ServletException;
import javax.servlet.http.Cookie;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

public class BarvaPozadi extends HttpServlet {

    String[] colors = {
        "FFFFFF",
        "000000",
        "78866B",
        "C41E3A",
        "960018",
        "ED9121",
        "DE3163",
        "007BA7",
        "2A52BE",
        "7FFF00",
        "D2691E",
        "7B3F00",
        "0047AB",
        "B87333",
        "FF7F50",
        "FBEC5D",
        "6495ED",
        "FFFDD0",
        "DC143C",
        "00FFFF"
    };
    String[] colorNames = {
        "Bílá",
        "Černá",
        "Maskování",
        "Kardinál",
        "Karmínová",
        "Mrkvová",
        "Třešňová",
        "Blankyt",
        "Blankytně modrá",
        "Svítivě zelená",
        "Čokoláda",
        "Skořice",
        "Kobalt",
        "Měď",
        "Lososová",
        "Zrní",
        "Královská modř",
        "Krémová",
        "Karmínová",
        "Modrozelená"
    };

    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        response.setCharacterEncoding("utf-8");
        Cookie[] cookies = request.getCookies();
        String colorIndex = "";
        if (cookies != null) {
            for (int i = 0; i < cookies.length; i++) {
                if (cookies[i].getName().equals("colorIndex")) {
                    colorIndex = cookies[i].getValue();
                }
            }
        }

        PrintWriter out = response.getWriter();
        HtmlWriter.printHeader(out, "Barvy pozadí");
        out.println("<p>Příliš žluťoučký kůň úpěl ďábelské ódy.</p>");

        int index = -1;
        try {
            if (!colorIndex.equals("")) {
                index = Integer.parseInt(colorIndex);
            }
        } catch (NumberFormatException e) {
            HtmlWriter.printError(out, "Chybná barva!");
            HtmlWriter.printFooter(out);
            return;
        }

        printColor(out, index);
        out.println("<form method=\"post\" action=\".\"><fieldset>");
        out.print("<label for=\"colorIndex\">Vyberte barvu:</label>");
        printCombo(out, "colorIndex", index);

        out.println("<input type=\"submit\" name=\"submit\" /></fieldset></form>");
        HtmlWriter.printFooter(out);
    }

    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        String colorIndex = request.getParameter("colorIndex");
        Cookie c = new Cookie("colorIndex", colorIndex);
        response.addCookie(c);
        response.sendRedirect(".");
    }

    private void printCombo(PrintWriter out, String idname, int index) {

        out.printf("%n<select id=\"%s\" name=\"%1$s\">%n", idname);
        for (int i = 0; i < colors.length; i++) {
            String selected = "";
            if (index == i) {
                selected = " selected=\"selected\"";
            }
            out.println("\t\t<option value=\"" + i + "\"" + selected + ">" + colorNames[i] + "</option>%n");
        }
        out.println("</select>");
    }

    private void printColor(PrintWriter out, int index) {
        if (index < 0 || index > colors.length) {
            index = 0;
        }
        out.println("<style type=\"text/css\">");
        out.printf("html,p {background-color:#%s !important;}%n", colors[index]);
        out.println("</style>");

    }
}
